/* 
 *	The HTE Editor
 *	htpe.h
 *
 *	Copyright (C) 1999,2000 Stefan Weyergraf (stefan@weyergraf.de)
 *
 *	This program is free software; you can redistribute it and/or modify
 *	it under the terms of the GNU General Public License version 2 as
 *	published by the Free Software Foundation.
 *
 *	This program is distributed in the hope that it will be useful,
 *	but WITHOUT ANY WARRANTY; without even the implied warranty of
 *	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *	GNU General Public License for more details.
 *
 *	You should have received a copy of the GNU General Public License
 *	along with this program; if not, write to the Free Software
 *	Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

#ifndef __HTPE_H__
#define __HTPE_H__

#include "viewers.h"
#include "pestruct.h"
#include "htpeexp.h"
#include "htpeimp.h"
#include "htpedimp.h"

extern viewer_int htpe_int;

struct pe_section_headers {
	int section_count;
	PE_SECTION_HEADER *sections;
};

struct ht_pe_shared_data {
	PE_HEADER coffheader;
	PE_OPTIONAL_HEADER pe32header;
	pe_section_headers sections;
	ht_pe_export exports;
	ht_pe_import imports;
	ht_pe_dimport dimports;
};

class ht_pe: public ht_xgroup {
private:
	ht_pe_shared_data *pe_shared;
public:
	ht_pe(bounds *b, htfile *file);
	~ht_pe();
};

int pe_rva_to_section(pe_section_headers *section_headers, ADDR rva, int *section);
int pe_rva_to_ofs(pe_section_headers *section_headers, ADDR rva, dword *ofs);
int pe_rva_is_valid(pe_section_headers *section_headers, ADDR rva);

int pe_ofs_to_rva(pe_section_headers *section_headers, dword ofs, ADDR *rva);
int pe_ofs_to_section(pe_section_headers *section_headers, dword ofs, ADDR *section);
int pe_ofs_to_rva_and_section(pe_section_headers *section_headers, dword ofs, ADDR *rva, ADDR *section);

#endif /* !__HTPE_H__ */
