/* 
 *	The HTE Editor
 *	main.cc
 *
 *	Copyright (C) 1999,2000 Stefan Weyergraf (stefan@weyergraf.de)
 *
 *	This program is free software; you can redistribute it and/or modify
 *	it under the terms of the GNU General Public License version 2 as
 *	published by the Free Software Foundation.
 *
 *	This program is distributed in the hope that it will be useful,
 *	but WITHOUT ANY WARRANTY; without even the implied warranty of
 *	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *	GNU General Public License for more details.
 *
 *	You should have received a copy of the GNU General Public License
 *	along with this program; if not, write to the Free Software
 *	Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

#include <stdio.h>

#include "htapp.h"
#include "htcfg.h"
#include "htcurses.h"
#include "htdialog.h"
#include "htfile.h"
#include "hthelp.h"
#include "htidle.h"
#include "htkeyb.h"
#include "htobj.h"
#include "htpal.h"
#include "htinfo.h"
#include "viewers.h"

char *htcopyrights[]=
{
	ht_loadtitle,
	htanalyser_loadtitle,
	0
};

void idle()
{
	do_idle();
}

void copyright()
{
	char **copyrights=htcopyrights;
	while (*copyrights) {
		printf(*copyrights);
		printf("\n");
		copyrights++;
	}
	printf(htlicenseinfo);
}

void help()
{
	copyright();
	printf("Syntax: "ht_name" file(s)\n");
	exit(1);
}

void init()
{
	pal_grp=new palette_group();	/* FIXME: bad solution... */
	init_obj();
	init_dialog();
	init_app();
	init_help();
/* test: */
/*	htfile *f=new htrawfile("inf/infview.ger", "rb");
	if (f->geterror()) {
		printf("helpfile not found !\n");
		exit(1);
	}
	read_info_file(f);
	delete f;*/
}

void done()
{
	done_help();
	done_app();
	done_dialog();
	done_obj();
	delete pal_grp;
}

int exitht=0;

void sendkeymsg(int key)
{
	htmsg msg;
	msg.msg=htm_keypressed;
	msg.type=htmt_nothing;
	msg.data_int=key;
	app->sendmsg(&msg);
	if (msg.msg==htm_keypressed) {
		switch (msg.data_int) {
			case K_Escape:
				exitht=1;
				app->clearmsg(&msg);
				break;
		}
	}
}

int main(int argc, char *argv[])
{
	if (argc<2) help();
	init();

	char **copyrights=htcopyrights;
	while (*copyrights) {
		app->logf(*copyrights);
		copyrights++;
	}

	int filecount=0;
	for (int i=1; i<argc; i++) filecount+=app->new_window(argv[i]);
	if (!filecount) {
		done();
		printf("no files could be opened !\n");
		exit(1);
	}
	app->sendmsg(htm_draw, 0);
	while (!exitht) {
		if (htkeypressed()) {
			sendkeymsg(htgetkey());
			app->sendmsg(htm_draw, 0);
		}
		idle();
	}
	done();
//     write_cfg_file(viewer, viewer_count);
}
